<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>JS HOMEWORK 7</title>
</head>
<body>
<script>

    // basic task:

    //     function arrToListHTML(arr) {
    //
    //     let newList = document.createElement("ol");
    //
    //     newList.innerHTML = arr.map(item => {return `<li>${item}</li>`}).join("");
    //
    //     document.body.append(newList);
    // }

    // advanced task:

    function arrToListHTML(arr) {
        let testList = document.createElement("ul");

        for (let i = 0; i < arr.length; i++) {
            let liElement = document.createElement("li");
            liElement.innerHTML = arr[i];
            testList.append(liElement);

            if (typeof arr[i] === "object") {
                arr[i] = Object.values(arr[i]);
                let nestedList = document.createElement("ul");

                for (let j = 0; j < arr[i].length; j++) {
                    let nestedLiElement = document.createElement("li");
                    nestedLiElement.innerHTML = arr[i][j];
                    nestedList.append(nestedLiElement);

                    testList.append(nestedList);
                }
            }
        }
        document.body.append(testList);
    }

    function timerFunction () {
        timerDiv.innerText = timerVolumeSec;
        function timerStep () {
            timerVolumeSec = timerVolumeSec-1;
            return timerDiv.innerText = timerVolumeSec;
        }
        setInterval(timerStep, 1000);
    }

    function clearPage () {
        function clearBody () {
            document.body.innerHTML = "";
        }
        setTimeout(clearBody, timerVolumeSec*1000);
    }

//=============================================TIMER STYLE=============================================
    let timerDiv = document.createElement("div");
    document.body.prepend(timerDiv);

    let timerMargin = "5px";
    let timerWidth = "100px";
    let timerHeight = "100px";
    let timerLineHeight = "100px";
    let timerFontSize = "50px";
    let timerBorderRadius = "50%";

    timerDiv.style.display = "inline-block";
    timerDiv.style.margin = timerMargin;
    timerDiv.style.textAlign = "center";
    timerDiv.style.width = timerWidth;
    timerDiv.style.height = timerHeight;
    timerDiv.style.lineHeight = timerLineHeight;
    timerDiv.style.fontSize = timerFontSize;
    timerDiv.style.backgroundColor = "orange";
    timerDiv.style.borderRadius = timerBorderRadius;
//=====================================================================================================

    let testArrayOne = ['hello', 'world', 'Kiev', 'Kharkiv', 'Odessa', 'Lviv'];
    let testArrayTwo = ['1', '2', '3', 'sea', 'user', 23];
    let testArrayThree = ['1', ['a', 'b', "c", 'd', 'e'], 'sea', 3];
    let testArrayFour = ['1', {1:'a', 2:'b', 3:"c", 4:'d', 5:'e'}, 'sea', 3];

    let timerVolumeSec = 10;

    arrToListHTML(testArrayOne);
    arrToListHTML(testArrayTwo);
    arrToListHTML(testArrayThree);
    arrToListHTML(testArrayFour);
    clearPage();
    timerFunction();

</script>
</body>
</html>

<!--DOM - это обьектное представление html-документа в виде древообразной структуры.-->

<!--"Обьектное представление" означает, что DOM рассматирвает все вложенные элементы-->
<!--страницы в качестве обьектов, на которые можно влиять с помощью javaScript-кода.-->

<!--"Древообразная структура" строится за счет вложенных тегов и контента.-->
<!--Таким образом, корневым обьектом html-страницы является тег "html", который в свою-->
<!--очередь является родительстким элементом для тегов (1)"head" и (2)"body", а они являются-->
<!--"родителями" тегов (1)"meta", "title", "link" и (2)"nav", "main", "aside" соответственно.-->
<!--Автоматическое построение такой структуры означает, что используя javaScript мы всегда -->
<!--можем воздействовать на элементы страницы, независимо от уровня вложенности.-->